// C-Source file for Nibbles X
// Created 3/18/01; 4:28:53 PM
// Copyright (c)2001, Strife Software, Ross Franklin

#define OPTIMIZE_ROM_CALLS			// Use ROM Call Optimization
#define SAVE_SCREEN							// Save/Restore LCD Contents
#define MEMORY_VERSION "v1.00"

#define NUM_LEVELS 20
#define VERSION_PROTEC 2				// For future published versions, change this number
																// also autodetect older ones and import high

#define KEY_SELECT 1
#define KEY_TURBO	 2
#define KEY_AUP		 3
#define KEY_ALEFT	 4
#define KEY_ADOWN	 5
#define KEY_ARIGHT 6
#define KEY_ESCAPE 7

#define MENU_x 111							// All the menu cords are relative to these
#define MENU_y 6								// constants

#include <tigcclib.h>														// Include All Header Files

#include "C:\TIGCC\Projects\nibblevl.c"					// Include level vars
#include "C:\TIGCC\Projects\nibbtitle.c"				// Define title screen graphics
#include "C:\TIGCC\Projects\nibbgraph.c"				// Define game sprites

short _ti89;// _ti92plus;													// Produce a .89Z & .9XZ File

char buffString[10];
int firstMoves = 0; // Count the number of moves in the game

int snakeLength = 0;
int snakeDir = 0;
int snakeDir2 = 0;
int snakeXPos[164];
int snakeYPos[164];

long i = 0, j = 0;				// Counter
long timerTime = 0, moveTime = 0;
int	 keyPress = 0;			 // Queue for pressing keys; takes care of key-repeat
int	 gameSpeed = 2;			 // Speed of game (points depend on this; higher speed, more points.)
int	 gameLevel = 1;			 // Starting level
int	 openLevels = 1;			// Highest level availible in options menu
int	 gameControl = 0;		 // Game control
int	 levelWin = 0;			 // If you beat a level then this is nonzero
int	 levelLose = 0;			 // If you crash/timeout then this is nonzero
int	 movesMade = 0;			 // the number of moves
int	 eatApple = 0;			 // the number of moves
int	 gameOver = 0;			 // GameOver if non-zero
long nextLife = 0;			 // Get more lives for score

long score = 0;					 // Score of current game
long highScore = 0;			 // Highscore of all
char highName[4] = "RsF";			// Name of highscorer

int	 livesLeft = 5;						// Number of lives remaining
int	 timerCount = 59;

long highScore_temp = 0;
FILE *savefile;
INT_HANDLER save_int_1;

void startGame(void);										// -----------------------------------------
void drawMenu(int _menu);								// DEIFINE ALL FUNCTIONS HERE --------------	
void viewOptions(void);									// -----------------------------------------
void loadLevel(int level);
void levelReady(void);
void DrawNumb(int xPos, int yPos,long value);
void DrawGrayNumb(int xPos, int yPos, long value);
int	 keyPushed(int keyQ);
int	 turboUpdate(int takeFill);

int	 mainSelect = 0;							// Menu selection for the main menu
int	 optionSelect = 0;							// Menu selection for the options menu

void _main(void)																	// Startup with main menu:
{
	int refreshScreen = 0;					// if nonzero then refresh the main menu
	int quitGame = 0;								// If non-zero then quit the game

	save_int_1 = GetIntVec (AUTO_INT_1);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);					// redirect auto-int 1 to "nothing"

	randomize();																		// Intalize the random number generater with random value

	savefile = fopen("nibb89s", "rb");							// read saved data if availible
	if (savefile != NULL) {
		if (fgetc(savefile) == VERSION_PROTEC) {
			highScore_temp = 0;
			j = fgetc(savefile);
			while (j != 0) {
				highScore_temp += j;
				j = fgetc(savefile);
			}
			if (highScore_temp == 1)
			highScore_temp = 0;
			highScore = highScore_temp;
			
			i = 0;
			for (j = 0 ; j <= 3 ; j++) {
				highName[j] = fgetc(savefile);
			}
			while (fgetc(savefile) != 0) {
			}
			gameSpeed = fgetc(savefile);
			gameLevel = fgetc(savefile);
			gameControl = fgetc(savefile);
			openLevels = fgetc(savefile);
		}
	}
	fclose(savefile);
	
	refreshScreen = 1;															// Draw main menu to begin game
	mainSelect = 0;																	// Start with "New Game" selected
	keyPress = 1;																		// Nothing has been pressed
	
	quitGame = 0;

	if (!GrayMode (GRAY_ON)) return;								// ---------------------------------
	display_main_background(0);											// Display logo
	SetPlane(LIGHT_PLANE);													// Turn on Grayscale mode on
	FontSetSys(F_8x10);
	DrawStr(44, 78, "Presents:", A_XOR);						// Write "Presents" underneath logo
	DrawStr(42, 77, "Presents:", A_NORMAL);					// Write "Presents" underneath logo
	DrawStr(42, 77, "Presents:", A_XOR);						// Write "Presents" underneath logo
	SetPlane(DARK_PLANE);
	DrawStr(42, 77, "Presents:", A_XOR);						// Write "Presents" underneath logo
	for (i = 0 ; i < 300000 ; i++);									// Pause while logo is diaplayed

	while (quitGame == 0) {													// So long as we haven't quit the game ...
    for (i = 0 ; i < 600 && quitGame == 0 ; i++) {
      if (refreshScreen) {                        // if the screen requires refeshing
        SetPlane(LIGHT_PLANE);
        ClrScr();
        SetPlane(DARK_PLANE);
        ClrScr();

        // Draw the menu background:
        display_main_background(1);

        // Draw the highscore & name:
        SetPlane(DARK_PLANE);
        FontSetSys(F_6x8);
        DrawStr(0, 92, "High:", A_XOR);
        DrawGrayNumb(30, 92, highScore);
        sprintf(buffString, "High:%ld", highScore);
        DrawStr((int)strlen(buffString) * 6 - 1, 92, "-", A_XOR);
        DrawStr((int)strlen(buffString) * 6 + 5, 92, highName, A_XOR);
        
        // Draw the version number:
        FontSetSys(F_4x6);
        SetPlane(DARK_PLANE);
        DrawStr(137, 93, "v2.00", A_XOR);

        // Draw in the main menu:
        drawMenu(0);
        
        // No need to keep refreashing over and over.
        refreshScreen = 0;
      }

      //------------------------------------------------------------//
      //------ If I ever make an Auto-Power-Down, put it here ------//
      //------------------------------------------------------------//
      
      if (keyPushed(KEY_AUP) && !keyPress) {                                                                  // If up has been pressed
        Sprite8(MENU_x, (mainSelect * 9 ) + MENU_y, 8, crosshair_light, GetPlane(LIGHT_PLANE), SPRT_XOR);     // Xor Crosshair
        Sprite8(MENU_x, (mainSelect * 9 ) + MENU_y, 8, crosshair_dark, GetPlane(DARK_PLANE), SPRT_XOR);       // |
        mainSelect--;                                                                                         // Move slector up
        if (mainSelect == -1)                                                                                 // If move above top
          mainSelect = 2;                                                                                     //  move down to last
        Sprite8(MENU_x, (mainSelect * 9 ) + MENU_y, 8, crosshair_light, GetPlane(LIGHT_PLANE), SPRT_XOR);     // Xor Crosshair
        Sprite8(MENU_x, (mainSelect * 9 ) + MENU_y, 8, crosshair_dark, GetPlane(DARK_PLANE), SPRT_XOR);       // |
        keyPress = 1;                                                                                         // Key has been pressed
      }
      if (keyPushed(KEY_ADOWN) && !keyPress) {                                                                // If down has been pressed
        Sprite8(MENU_x, (mainSelect * 9 ) + MENU_y, 8, crosshair_light, GetPlane(LIGHT_PLANE), SPRT_XOR);     // Xor Crosshair
        Sprite8(MENU_x, (mainSelect * 9 ) + MENU_y, 8, crosshair_dark, GetPlane(DARK_PLANE), SPRT_XOR);       // |
        mainSelect++;                                                                                         // Move slector down
        if (mainSelect == 3)                                                                                  // If move below bottom
          mainSelect = 0;                                                                                     //  move up to top
        Sprite8(MENU_x, (mainSelect * 9 ) + MENU_y, 8, crosshair_light, GetPlane(LIGHT_PLANE), SPRT_XOR);     // Xor Crosshair
        Sprite8(MENU_x, (mainSelect * 9 ) + MENU_y, 8, crosshair_dark, GetPlane(DARK_PLANE), SPRT_XOR);       // |
        keyPress = 1;                                                                                         // Key has been pressed
      }

      if (keyPushed(KEY_SELECT) && !keyPress && mainSelect == 0) {  // If New Game has been selected
        keyPress = 1;
        startGame();
        refreshScreen = 1;
      }
      if (keyPushed(KEY_SELECT) && !keyPress && mainSelect == 1) {  // If Options has been selected
        keyPress = 1;
        viewOptions();
      }
      if (keyPushed(KEY_SELECT) && !keyPress && mainSelect == 2) {  // If Credits has been selected
        keyPress = 1;
        GrayMode (GRAY_OFF);                      // Turn off Grayscale mode
        credits();
        if (!GrayMode (GRAY_ON)) return;          // Turn on Grayscale mode
        refreshScreen = 1;
      }
//      if (keyPushed(KEY_SELECT) && !keyPress && mainSelect == 3)  // If Quit has been selected
//      quitGame = 1;
      if (keyPushed(KEY_ESCAPE) && !keyPress)                                                           // If ESC has been pressed
        quitGame = 1;

      if (!(keyPushed(KEY_AUP) || keyPushed(KEY_ADOWN) || keyPushed(KEY_SELECT) || keyPushed(KEY_ESCAPE)))
        keyPress = 0;
    }
  }
  // *************************************************************************
  // *************************************************************************
  // *******    QUIT THE GAME - Ideally it will never come to this    ********

  GrayMode (GRAY_OFF);                                                                                      // Turn off grayscale mode
  clrscr();
  while (keyPushed(KEY_SELECT) || keyPushed(KEY_ESCAPE)) { }                                                // Wait until user has let
  SetIntVec (AUTO_INT_1, save_int_1);                                                                       // Restore auto-int 1
  savefile = fopen("nibb89s", "wb");                                                                        // go of ESC,Enter, or 2nd

  fputc(VERSION_PROTEC, savefile);
  highScore_temp = highScore;
  if (highScore_temp == 0)
  highScore_temp = 1;
  while (highScore_temp > 200) {
    fputc(200, savefile);
    highScore_temp -= 200;
  }
  fputc(highScore_temp, savefile);
  fputc(0, savefile);
  for (i = 0 ; i < (int)strlen(highName) + 1 ; i ++)
    fputc(highName[i], savefile);
  fputc(0, savefile);
  fputc(gameSpeed, savefile);
  fputc(gameLevel, savefile);
  fputc(gameControl, savefile);
  fputc(openLevels, savefile);
  fputc(0, savefile);
  fputs("INI", savefile);
  fputc(0, savefile);
  fputc(OTH_TAG, savefile);
  fclose(savefile);
  
}

void drawMenu(int _menu)
{
  SetPlane(DARK_PLANE);   // All of the menu stuff is draw in dark gray
  FontSetSys(F_4x6);      // The text for the menus is in small font
  
  if (_menu == 0) {       // If we want to draw the main menu...
    Sprite8(MENU_x, (mainSelect * 9 ) + MENU_y, 8, crosshair_light, GetPlane(LIGHT_PLANE), SPRT_XOR);     // Xor Crosshair
    Sprite8(MENU_x, (mainSelect * 9 ) + MENU_y, 8, crosshair_dark, GetPlane(DARK_PLANE), SPRT_XOR);       // |
    DrawStr(MENU_x + 8, MENU_y, "New Game", A_XOR);
    DrawStr(MENU_x + 8, MENU_y + 9, "Options", A_XOR);
    DrawStr(MENU_x + 8, MENU_y + 18, "Credits", A_XOR);
  }
  else {              // Else if we want to draw the options menu...
    Sprite8(MENU_x, (optionSelect * 9 ) + MENU_y, 8, crosshair_light, GetPlane(LIGHT_PLANE), SPRT_XOR);    // Xor Crosshair
    Sprite8(MENU_x, (optionSelect * 9 ) + MENU_y, 8, crosshair_dark, GetPlane(DARK_PLANE), SPRT_XOR);     // |
    DrawStr(MENU_x + 8, MENU_y, "Speed:", A_XOR);
    DrawGrayNumb(MENU_x + 31, MENU_y, gameSpeed);
    DrawStr(MENU_x + 8, MENU_y + 9, "Level:", A_XOR);
    DrawGrayNumb(MENU_x + 31, MENU_y + 9, gameLevel);
    DrawStr(MENU_x + 8, MENU_y + 18, "Controls:", A_XOR);
    if (gameControl == 0)
      DrawStr(MENU_x + 12, MENU_y + 24, " normal", A_XOR);
    else
      DrawStr(MENU_x + 12, MENU_y + 24, " right/left", A_XOR);
  }
}

void viewOptions(void)
{
  int quitOptions = 0;
  
  drawMenu(0);    // Erase the main menu
  quitOptions = 0;
  optionSelect = 0;

  drawMenu(1);    // Draw the options menu in its place

  while (quitOptions == 0) {                      // So long as we're still in options ...
		for ( i = 0; i < 600 && quitOptions == 0 ; i++) {

			if (keyPushed(KEY_AUP) && !keyPress) {																																	// If up has been pressed
				Sprite8(MENU_x, (optionSelect * 9 ) + MENU_y, 8, crosshair_light, GetPlane(LIGHT_PLANE), SPRT_XOR);		// Xor Crosshair
				Sprite8(MENU_x, (optionSelect * 9 ) + MENU_y, 8, crosshair_dark, GetPlane(DARK_PLANE), SPRT_XOR);			// |
				optionSelect--;																																												// Move slector up
				if (optionSelect == -1)																																								// If move above top
					optionSelect = 2;																																										//	move down to last
				Sprite8(MENU_x, (optionSelect * 9 ) + MENU_y, 8, crosshair_light, GetPlane(LIGHT_PLANE), SPRT_XOR);		// Xor Crosshair
				Sprite8(MENU_x, (optionSelect * 9 ) + MENU_y, 8, crosshair_dark, GetPlane(DARK_PLANE), SPRT_XOR);			// |
				keyPress = 1;																																													// Key has been pressed
			}
			if (keyPushed(KEY_ADOWN) && !keyPress) {																																// If down has been pressed
				Sprite8(MENU_x, (optionSelect * 9 ) + MENU_y, 8, crosshair_light, GetPlane(LIGHT_PLANE), SPRT_XOR);		// Xor Crosshair
				Sprite8(MENU_x, (optionSelect * 9 ) + MENU_y, 8, crosshair_dark, GetPlane(DARK_PLANE), SPRT_XOR);			// |
				optionSelect++;																																												// Move slector down
				if (optionSelect == 3)																																								// If move below bottom
					optionSelect = 0;																																										//	move up to top
				Sprite8(MENU_x, (optionSelect * 9 ) + MENU_y, 8, crosshair_light, GetPlane(LIGHT_PLANE), SPRT_XOR);		// Xor Crosshair
				Sprite8(MENU_x, (optionSelect * 9 ) + MENU_y, 8, crosshair_dark, GetPlane(DARK_PLANE), SPRT_XOR);			// |
				keyPress = 1;																																													// Key has been pressed
			}
			if (keyPushed(KEY_ALEFT) && !keyPress && optionSelect == 0) {		// If left has been pressed on speed
				DrawGrayNumb(MENU_x + 31, MENU_y, gameSpeed);
				gameSpeed--;
				if (gameSpeed == 0)
					gameSpeed = 4;
				DrawGrayNumb(MENU_x + 31, MENU_y, gameSpeed);
				keyPress = 1;
			}
			if (keyPushed(KEY_ARIGHT) && !keyPress && optionSelect == 0) {	// If right has been pressed on speed
				DrawGrayNumb(MENU_x + 31, MENU_y, gameSpeed);
				gameSpeed++;
				if (gameSpeed == 5)
					gameSpeed = 1;
				DrawGrayNumb(MENU_x + 31, MENU_y, gameSpeed);
				keyPress = 1;
			}
			if (keyPushed(KEY_ALEFT) && !keyPress && optionSelect == 1) {		// If left has been pressed on level
				DrawGrayNumb(MENU_x + 31, MENU_y + 9, gameLevel);
				gameLevel--;
				if (gameLevel == 0)
					gameLevel = openLevels;
				DrawGrayNumb(MENU_x + 31, MENU_y + 9, gameLevel);
				keyPress = 1;
			}
			if (keyPushed(KEY_ARIGHT) && !keyPress && optionSelect == 1) {	// If right has been pressed on level
				DrawGrayNumb(MENU_x + 31, MENU_y + 9, gameLevel);
				gameLevel++;
				if (gameLevel == openLevels + 1)
					gameLevel = 1;
				DrawGrayNumb(MENU_x + 31, MENU_y + 9, gameLevel);
				keyPress = 1;
			}
			if ((keyPushed(KEY_ALEFT) || keyPushed(KEY_ARIGHT)) && !keyPress && optionSelect == 2){
				if (gameControl == 0)																					// If left or right has been pressed on control
					gameControl = 1;
				else
					gameControl = 0;
				DrawStr(MENU_x + 12, MENU_y + 24, " normal", A_XOR);
				DrawStr(MENU_x + 12, MENU_y + 24, " right/left", A_XOR);
				keyPress = 1;
			}

			if (keyPushed(KEY_ESCAPE) && !keyPress) {
				keyPress = 1;
				quitOptions = 1;
			}

			if (!(keyPushed(KEY_SELECT) || keyPushed(KEY_ESCAPE) || keyPushed(KEY_AUP) || keyPushed(KEY_ALEFT) || keyPushed(KEY_ADOWN) || keyPushed(KEY_ARIGHT)))
			keyPress = 0;
		}
	}
	drawMenu(1);		// Earse the options menu
	drawMenu(0);		// Redraw the main menu again
}

void loadLevel(int level)
{
	int appleCount = 10;
	int addApples = 0;
	int randomApple[2] = {0, 0};
	int dirChanged = 0;
	
	SetPlane(LIGHT_PLANE);
	ClrScr();
	SetPlane(DARK_PLANE);
	ClrScr();
	for (i = 0 ; i < 20 ; i++) {
		Sprite8(i * 8, 0, 8, brick_0, GetPlane(DARK_PLANE), SPRT_XOR);
		Sprite8(i * 8, 0, 8, brick_1, GetPlane(LIGHT_PLANE), SPRT_XOR);
	}
	for (i = 1 ; i < 9 ; i++) {
		Sprite8(0, i * 8 , 8, brick_0, GetPlane(DARK_PLANE), SPRT_XOR);
		Sprite8(0, i * 8 , 8, brick_1, GetPlane(LIGHT_PLANE), SPRT_XOR);
		Sprite8(152, i * 8 , 8, brick_0, GetPlane(DARK_PLANE), SPRT_XOR);
		Sprite8(152, i * 8 , 8, brick_1, GetPlane(LIGHT_PLANE), SPRT_XOR);
	}
	FontSetSys(F_8x10);
	sprintf(buffString, "Level %s", levelText[level]);
	DrawStr((160 - (strlen(buffString) * 8)) / 2, 18, buffString, A_NORMAL);
	FontSetSys(F_6x8);
	DrawStr(15, 40, "Lives:", A_NORMAL);
	DrawGrayNumb(56, 40, livesLeft);
	DrawStr(15, 49, "Score:", A_NORMAL);
	DrawGrayNumb(56, 49, score);
	DrawStr(15, 58, "1up at:", A_NORMAL);
	DrawGrayNumb(56, 58, nextLife);

	levelReady();
	
	SetPlane(LIGHT_PLANE);
	clrscr();
	SetPlane(DARK_PLANE);
	clrscr();
	snakeLength = 3;
	snakeXPos[0] = levelStart[levelOrder[level]][1];
	snakeYPos[0] = levelStart[levelOrder[level]][0];
	snakeXPos[1] = levelStart[levelOrder[level]][1];
	snakeYPos[1] = levelStart[levelOrder[level]][0];
	snakeXPos[2] = levelStart[levelOrder[level]][1];
	snakeYPos[2] = levelStart[levelOrder[level]][0];
	snakeXPos[3] = levelStart[levelOrder[level]][1];
	snakeYPos[3] = levelStart[levelOrder[level]][0];

	DrawLine(0, 89, 68, 89, A_XOR);																											// Draw timer box
	DrawLine(60, 90, 60, 98, A_XOR);																										//		*
	DrawLine(68, 90, 68, 98, A_XOR);																										//		*
	DrawLine(40, 90, 40, 92, A_XOR);																										//		*
	DrawLine(20, 90, 20, 92, A_XOR);																										//		*
	DrawLine(0, 90, 0, 92, A_XOR);																											//		*
	ScrRectFill(&(SCR_RECT){{0, 94, 59, 97}},&(SCR_RECT){{0, 94, 59, 97}}, A_NORMAL);		// Timer fill
	ScrRectFill(&(SCR_RECT){{62, 90, 66, 98}},&(SCR_RECT){{62, 90, 66, 98}}, A_NORMAL); // Turbo fill
	
	DrawStr(69, 90, "Score:", A_XOR);
	DrawGrayNumb(104, 90, score);
	
	for ( i = 0 ; i < 11 ; i++) {								// Copy level into buffer
		for ( j = 0 ; j < 20 ; j++) {							// ** Important **
			levelC[i][j] = levelD[levelOrder[level]][i][j];
		}
	}
	for (addApples = 0 ; addApples < 10 ; ) {		// Add apples into buffer
		randomApple[0] = random(9)+1;							// Do so until there are 10 of them
		randomApple[1] = random(18)+1;
		if (levelC[randomApple[0]][randomApple[1]] == 0) {
			levelC[randomApple[0]][randomApple[1]] = 2;
			addApples++;
		}
	}
	for ( i = 0 ; i < 11 ; i++) {
		for ( j = 0 ; j < 20 ; j++) {
			if (levelC[i][j] == 1) {
				Sprite8(j * 8, i * 8, 8, brick_0, GetPlane(DARK_PLANE), SPRT_XOR);		 // Draw all of the bricks
				Sprite8(j * 8, i * 8, 8, brick_1, GetPlane(LIGHT_PLANE), SPRT_XOR);
			}
			if (levelC[i][j] == 2) {
				Sprite8(j * 8, i * 8, 8, apple_0, GetPlane(DARK_PLANE), SPRT_XOR);	// Draw all of the apples
				Sprite8(j * 8, i * 8, 8, apple_1, GetPlane(LIGHT_PLANE), SPRT_XOR);
			}
		}
	}
	if (startDirec[levelOrder[level]] == 0 || startDirec[levelOrder[level]] == 2)
	Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, snake_head_v, GetPlane(DARK_PLANE), SPRT_XOR); // Draw the start of the snake
	if (startDirec[levelOrder[level]] == 1 || startDirec[levelOrder[level]] == 3)
	Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, snake_head_h, GetPlane(DARK_PLANE), SPRT_XOR); // Draw the start of the snake

	snakeLength = 3;
	snakeXPos[0] = levelStart[levelOrder[level]][0];
	snakeYPos[0] = levelStart[levelOrder[level]][1];
	snakeXPos[1] = -1;
	snakeYPos[1] = -1;
	snakeXPos[2] = -1;
	snakeYPos[2] = -1;
	snakeXPos[3] = -1;
	snakeYPos[3] = -1;
	snakeXPos[4] = -1;
	snakeYPos[4] = -1;
	
	snakeDir = startDirec[levelOrder[level]];
	snakeDir2 = startDirec[levelOrder[level]];
	eatApple = 0;
	movesMade = 0;
	moveTime = 0;
	timerTime = 0;
	timerCount = 59;
	appleCount = 10;
				
	while (levelLose == 0 && levelWin == 0 && gameOver == 0) {
		timerTime++;
		if (keyPushed(KEY_TURBO) && turboUpdate(0)) moveTime += 3;			// If we are pressing turbo
		else moveTime++;

//		if (Key_is_pressed) {
		if (gameControl == 0) {																																		// If we are using normal controls
			if (keyPushed(KEY_AUP) && !keyPress && snakeDir != 2 && dirChanged == 0) {							// If up has been pressed
				snakeDir = 0;
				dirChanged = 1;
				keyPress = 1;
			}
			if (keyPushed(KEY_ADOWN) && !keyPress && snakeDir != 0 && dirChanged == 0) {						// If down has been pressed
				snakeDir = 2;
				dirChanged = 1;
				keyPress = 1;
			}
			if (keyPushed(KEY_ALEFT) && !keyPress && snakeDir != 3 && dirChanged == 0) {						// If left has been pressed
				snakeDir = 1;
				dirChanged = 1;
				keyPress = 1;
			}
			if (keyPushed(KEY_ARIGHT) && !keyPress && snakeDir != 1 && dirChanged == 0) {						// If right has been pressed
				snakeDir = 3;
				dirChanged = 1;
				keyPress = 1;
			}
		}
		else {																																	// If we are using right/left controls
			if (keyPushed(KEY_ALEFT) && !keyPress && dirChanged == 0) {						// If left has been pressed
				snakeDir++;
				if (snakeDir == 4)
					snakeDir = 0;
				dirChanged = 1;
				keyPress = 1;
			}
			if (keyPushed(KEY_ARIGHT) && !keyPress && dirChanged == 0) {					// If right has been pressed
				snakeDir--;
				if (snakeDir == -1)
					snakeDir = 3;
				dirChanged = 1;
				keyPress = 1;
			}
		}
		if (keyPushed(KEY_ESCAPE) && !keyPress) {																// If escape is pressed
			levelLose = 1;
//			gameOver = 1;
			keyPress = 1;
		}
		
		if (!(keyPushed(KEY_SELECT) || keyPushed(KEY_ESCAPE) || keyPushed(KEY_AUP) || keyPushed(KEY_ALEFT) || keyPushed(KEY_ADOWN) || keyPushed(KEY_ARIGHT)))
		keyPress = 0;
//			do_somthing about it
//		if (half_secondtime_due) {
//			advance_timer
		if (((timerTime == (1450 - (4 * level)) && gameSpeed == 1) || (timerTime == (1250 - (6 * level)) && gameSpeed == 2) || (timerTime == (1100 - (10 * level)) && gameSpeed == 3) || (timerTime == (1000 - (14 * level)) && gameSpeed == 4)) && timerCount >= 0) {
			DrawLine(timerCount, 94, timerCount, 97, A_XOR);
			timerCount--;
			timerTime = 0;
			if (appleCount == -1) {
				if (levelC[levelStart[levelOrder[level]][1]][levelStart[levelOrder[level]][0]] == 4) {
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, warp_1, GetPlane(DARK_PLANE), SPRT_XOR); // Draw the warp point
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, warp_2, GetPlane(DARK_PLANE), SPRT_XOR); // Draw the warp point
					levelC[levelStart[levelOrder[level]][1]][levelStart[levelOrder[level]][0]] = 5;
				}
				else if (levelC[levelStart[levelOrder[level]][1]][levelStart[levelOrder[level]][0]] == 5) {
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, warp_2, GetPlane(DARK_PLANE), SPRT_XOR); // Draw the warp point
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, warp_1, GetPlane(DARK_PLANE), SPRT_XOR); // Draw the warp point
					levelC[levelStart[levelOrder[level]][1]][levelStart[levelOrder[level]][0]] = 4;
				}
			}
		}
		if (timerCount == -1) {
			timerCount = 59;
			ScrRectFill(&(SCR_RECT){{0, 94, 59, 97}},&(SCR_RECT){{0, 94, 59, 97}}, A_NORMAL);								// Refil the timebar
			if (appleCount == -1) {
				appleCount = 0;
				if (levelC[levelStart[levelOrder[level]][1]][levelStart[levelOrder[level]][0]] == 4)
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, warp_1, GetPlane(DARK_PLANE), SPRT_XOR); // Erase the warp point
				else
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, warp_2, GetPlane(DARK_PLANE), SPRT_XOR); // Erase the warp point
				levelC[levelStart[levelOrder[level]][1]][levelStart[levelOrder[level]][0]] = 6;

				if (startDirec[levelOrder[level]] == 0 || startDirec[levelOrder[level]] == 2) {
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, gateH_0, GetPlane(DARK_PLANE), SPRT_XOR); // Draw the gate
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, gateH_1, GetPlane(LIGHT_PLANE), SPRT_XOR); // Draw the gate
				}
				else {
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, gateV_0, GetPlane(DARK_PLANE), SPRT_XOR); // Draw the gate
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, gateV_1, GetPlane(LIGHT_PLANE), SPRT_XOR); // Draw the gate
				}
			}
			while (appleCount < 10) {
				randomApple[0] = random(9)+1;							// Do so until there are 10 of them
				randomApple[1] = random(18)+1;
				if (levelC[randomApple[0]][randomApple[1]] == 0 && levelD[levelOrder[level]][randomApple[0]][randomApple[1]] == 0) {
					appleCount++;
					levelC[randomApple[0]][randomApple[1]] = 2;
					Sprite8(randomApple[1] * 8, randomApple[0] * 8, 8, apple_0, GetPlane(DARK_PLANE), SPRT_XOR);				// Draw all of the apples
					Sprite8(randomApple[1] * 8, randomApple[0] * 8, 8, apple_1, GetPlane(LIGHT_PLANE), SPRT_XOR);
				}
			}
		}


		// **************************************************************************
		// **************************************************************************
		// ****************			Move the snake when timer runs		*******************
		
		if ((moveTime >= 1000 && gameSpeed == 1) || (moveTime >= 900 && gameSpeed == 2) || (moveTime >= 800 && gameSpeed == 3) || (moveTime >= 700 && gameSpeed == 4)) {
			// HEY! - We're moving the snake right here:
			if (eatApple == 0) {
				levelC[snakeYPos[snakeLength]][snakeXPos[snakeLength]] = 0;
				Sprite8(snakeXPos[snakeLength] * 8, snakeYPos[snakeLength] * 8, 8, snake_body, GetPlane(DARK_PLANE), SPRT_XOR);		// Erase last body
			}
			eatApple = 0;


			if (snakeDir2 == 0 || snakeDir2 == 2)																										// Erase head
			Sprite8(snakeXPos[0] * 8, snakeYPos[0] * 8, 8, snake_head_v, GetPlane(DARK_PLANE), SPRT_XOR);
			else
			Sprite8(snakeXPos[0] * 8, snakeYPos[0] * 8, 8, snake_head_h, GetPlane(DARK_PLANE), SPRT_XOR);

			Sprite8(snakeXPos[0] * 8, snakeYPos[0] * 8, 8, snake_body, GetPlane(DARK_PLANE), SPRT_XOR);					// Replace head w/ body
			snakeDir2 = snakeDir;
			
			for ( j = snakeLength + 1 ; j > 0 ; j-- ) {																							// Advance all of the
				snakeXPos[j] = snakeXPos[j - 1];																											//		body w/out moveing
				snakeYPos[j] = snakeYPos[j - 1];																											//		the graphics
			}

			if (snakeDir == 0)																																			// Advance snake
			snakeYPos[0]--;
			if (snakeDir == 1)																																			// Advance snake
			snakeXPos[0]--;
			if (snakeDir == 2)																																			// Advance snake
			snakeYPos[0]++;
			if (snakeDir == 3)																																			// Advance snake
			snakeXPos[0]++;

			if (levelC[snakeYPos[0]][snakeXPos[0]] == 2) {																					// If you eat an apple
				Sprite8(snakeXPos[0] * 8, (snakeYPos[0] * 8), 8, apple_0, GetPlane(DARK_PLANE), SPRT_XOR);		// Erase the apple
				Sprite8(snakeXPos[0] * 8, (snakeYPos[0] * 8), 8, apple_1, GetPlane(LIGHT_PLANE), SPRT_XOR);
				levelC[snakeYPos[0]][snakeXPos[0]] = 0;
				DrawGrayNumb(104, 90, score);

				if (gameSpeed == 1)
				score += 9 * (level + 1);
				if (gameSpeed == 2)
				score += 10 * (level + 1);
				if (gameSpeed == 3)
				score += 11 * (level + 1);
				if (gameSpeed == 4)
				score += 12 * (level + 1);

				DrawGrayNumb(104, 90, score);
				appleCount--;
				snakeLength++;
				eatApple = 1;
			}
			if (levelC[snakeYPos[0]][snakeXPos[0]] == 1 || levelC[snakeYPos[0]][snakeXPos[0]] == 3 || levelC[snakeYPos[0]][snakeXPos[0]] == 6) {
				Sprite8(snakeXPos[1] * 8, snakeYPos[1] * 8, 8, snake_body, GetPlane(DARK_PLANE), SPRT_XOR);
				Sprite8(snakeXPos[1] * 8, snakeYPos[1] * 8, 8, snake_crash, GetPlane(DARK_PLANE), SPRT_XOR);
				Sprite8(snakeXPos[snakeLength + 1] * 8, snakeYPos[snakeLength + 1] * 8, 8, snake_body, GetPlane(DARK_PLANE), SPRT_XOR);
				for (i = 0 ; i < 200000 ; i++) {}
				levelLose = 1;																																				// If you crash
				keyPress = 1;
				continue;
			}

			if (levelC[snakeYPos[0]][snakeXPos[0]] == 4 || levelC[snakeYPos[0]][snakeXPos[0]] == 5) {
				levelWin = 1;																																					// If you win
				score += (40 * (level + 1)) + (5 * gameSpeed);
				keyPress = 1;
				continue;
			}
			
			if (levelC[snakeYPos[0]][snakeXPos[0]] == 7) {																					// If you get
				levelC[snakeYPos[0]][snakeXPos[0]] = 0;																								// a turbo thing
				turboUpdate(2); // Fill tubro bar
				Sprite8(snakeXPos[0] * 8, snakeYPos[0] * 8, 8, turbo_0, GetPlane(DARK_PLANE), SPRT_XOR);	// Draw the turbo thing
				Sprite8(snakeXPos[0] * 8, snakeYPos[0] * 8, 8, turbo_1, GetPlane(LIGHT_PLANE), SPRT_XOR);
				DrawGrayNumb(104, 90, score);
				score += 10 * (level +1);
				DrawGrayNumb(104, 90, score);
			}
			if (levelC[snakeYPos[0]][snakeXPos[0]] == 10) {																					// If you get
				levelC[snakeYPos[0]][snakeXPos[0]] = 0;																								// a timer addition
				timerCount += (25 - level);
				if (timerCount > 59)
				timerCount = 59;
				DrawLine(0, 94, timerCount, 94, A_NORMAL);
				DrawLine(0, 95, timerCount, 95, A_NORMAL);
				DrawLine(0, 96, timerCount, 96, A_NORMAL);
				DrawLine(0, 97, timerCount, 97, A_NORMAL);
				Sprite8(snakeXPos[0] * 8, snakeYPos[0] * 8, 8, clock_0, GetPlane(DARK_PLANE), SPRT_XOR);
				Sprite8(snakeXPos[0] * 8, snakeYPos[0] * 8, 8, clock_1, GetPlane(LIGHT_PLANE), SPRT_XOR);
				DrawGrayNumb(104, 90, score);
				score += 10 * (level +1);
				DrawGrayNumb(104, 90, score);
			}

			levelC[snakeYPos[0]][snakeXPos[0]] = 3;		// ************************************************************
																								// After making sure the space in front of the snake is clear,
																								// add it to the level buffer so that no turbos or clocks apear
																								// right when you move

			// *********************************************************
			// *************		Add the turbo recharger		**************
			if (random(100) + 1 == 100) {
				for (addApples = 0 ; addApples < 1 ; ) {		// Find a place on the map
					randomApple[0] = random(9)+1;							// where there is nothing
					randomApple[1] = random(18)+1;
					if (levelC[randomApple[0]][randomApple[1]] == 0 && levelD[levelOrder[level]][randomApple[0]][randomApple[1]] == 0) {
						levelC[randomApple[0]][randomApple[1]] = 7;
						Sprite8(randomApple[1] * 8, randomApple[0] * 8, 8, turbo_0, GetPlane(DARK_PLANE), SPRT_XOR);	// Draw the turbo thing
						Sprite8(randomApple[1] * 8, randomApple[0] * 8, 8, turbo_1, GetPlane(LIGHT_PLANE), SPRT_XOR);	 // Draw the turbo thing
						addApples++;
					}
				}
			}
			// *********************************************************
			// *************		Add the timer addition		**************
			if (random(100) + 1 == 100) {
				for (addApples = 0 ; addApples < 1 ; ) {		// Find a place on the map
					randomApple[0] = random(9)+1;							// where there is nothing
					randomApple[1] = random(18)+1;
					if (levelC[randomApple[0]][randomApple[1]] == 0 && levelD[levelOrder[level]][randomApple[0]][randomApple[1]] == 0) {
						levelC[randomApple[0]][randomApple[1]] = 10;
						Sprite8(randomApple[1] * 8, randomApple[0] * 8, 8, clock_0, GetPlane(DARK_PLANE), SPRT_XOR);	// Draw the clock thing
						Sprite8(randomApple[1] * 8, randomApple[0] * 8, 8, clock_1, GetPlane(LIGHT_PLANE), SPRT_XOR);	 // Draw the clock thing
						addApples++;
					}
				}
			}

			if (snakeDir == 0 || snakeDir == 2)																											// Redraw head at
			Sprite8(snakeXPos[0] * 8, snakeYPos[0] * 8, 8, snake_head_v, GetPlane(DARK_PLANE), SPRT_XOR);				// new location
			else
			Sprite8(snakeXPos[0] * 8, snakeYPos[0] * 8, 8, snake_head_h, GetPlane(DARK_PLANE), SPRT_XOR);

			if (movesMade != -1)
			movesMade++;
			moveTime = 0;

			if (movesMade > snakeLength) {
				if (startDirec[levelOrder[level]] == 0 || startDirec[levelOrder[level]] == 2) {
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, gateH_0, GetPlane(DARK_PLANE), SPRT_XOR); // Draw the gate
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, gateH_1, GetPlane(LIGHT_PLANE), SPRT_XOR); // Draw the gate
				}
				else {
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, gateV_0, GetPlane(DARK_PLANE), SPRT_XOR); // Draw the gate
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, gateV_1, GetPlane(LIGHT_PLANE), SPRT_XOR); // Draw the gate
				}
				levelC[levelStart[levelOrder[level]][1]][levelStart[levelOrder[level]][0]] = 6;
				movesMade = -1;
			}

			if (appleCount == 0) {

				if (startDirec[levelOrder[level]] == 0 || startDirec[levelOrder[level]] == 2) {
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, gateH_0, GetPlane(DARK_PLANE), SPRT_XOR); // Erase the gate
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, gateH_1, GetPlane(LIGHT_PLANE), SPRT_XOR); // Erase the gate
				}
				else {
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, gateV_0, GetPlane(DARK_PLANE), SPRT_XOR); // Erase the gate
					Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, gateV_1, GetPlane(LIGHT_PLANE), SPRT_XOR); // Erase the gate
				}
				Sprite8(levelStart[levelOrder[level]][0] * 8, levelStart[levelOrder[level]][1] * 8, 8, warp_1, GetPlane(DARK_PLANE), SPRT_XOR); // Draw the warp point
				levelC[levelStart[levelOrder[level]][1]][levelStart[levelOrder[level]][0]] = 4;
				appleCount = -1;
			}
			if (keyPushed(KEY_TURBO) && turboUpdate(0)) turboUpdate(1);
			dirChanged = 0;
		}
	}
}

void levelReady(void)
{
	int continueGame = 0;
	FontSetSys(F_6x8);
	DrawStr(53, 80, "- READY -", A_XOR);

	continueGame = 0;
	while (continueGame == 0) {			// Pause and wait for input
		for (i = 0 ; i < 600 && continueGame == 0 ; i++) {
			if (keyPushed(KEY_SELECT) && !keyPress) {
				keyPress = 1;
				continueGame = 1;
			}
			if (keyPushed(KEY_ESCAPE) && !keyPress) {
				keyPress = 1;
				gameOver = 1;
				continueGame = 1;
			}
			if (!(keyPushed(KEY_SELECT) || keyPushed(KEY_ESCAPE)))
			keyPress = 0;
		}
		if (continueGame == 0)
		DrawStr(65, 80, "READY", A_XOR);
	}
}

void startGame(void)
{
	char highNamet[4] = "AAA";
	long i, j;
	int continueGame = 0;
	int game1 = 0;
	int winWholeGame = 0;
	
	nextLife = 200;
	score = 0;
	livesLeft = 4;
	gameOver = 0;

	for (game1 = gameLevel - 1; game1 < NUM_LEVELS && gameOver == 0 ; game1++) {
		do {
			levelLose = 0;
			levelWin = 0;
			loadLevel(game1);

			if ((gameLevel == 1) && (game1 >= openLevels))
				openLevels = game1;

			while (score > nextLife) {										// If you get enough score for
				livesLeft++;																//	another life, then add a life
				nextLife = nextLife * 2;										//	and increment nextlife_goal
			}
			if (levelLose == 1)
			livesLeft--;
			if (levelWin == 1 && game1 == 19)
			winWholeGame = 1;
			if (livesLeft == 0)
			gameOver = 1;
		} while (levelLose == 1 && gameOver == 0);
	}

	// ****************************************************************************
	// ***********		If you lose the game, GAME OVER / highscore		***************
	SetPlane(LIGHT_PLANE);
	clrscr();
	SetPlane(DARK_PLANE);
	clrscr();
	for (i = 0 ; i < 20 ; i++) {
		Sprite8(i * 8, 0, 8, brick_0, GetPlane(DARK_PLANE), SPRT_XOR);
		Sprite8(i * 8, 0, 8, brick_1, GetPlane(LIGHT_PLANE), SPRT_XOR);
	}
	for (i = 1 ; i < 8 ; i++) {
		Sprite8(0, i * 8 , 8, brick_0, GetPlane(DARK_PLANE), SPRT_XOR);
		Sprite8(0, i * 8 , 8, brick_1, GetPlane(LIGHT_PLANE), SPRT_XOR);
		Sprite8(152, i * 8 , 8, brick_0, GetPlane(DARK_PLANE), SPRT_XOR);
		Sprite8(152, i * 8 , 8, brick_1, GetPlane(LIGHT_PLANE), SPRT_XOR);
	}
	if (winWholeGame)
		score = score * 1.1 * livesLeft;								// If you win, then you get a bonus witch gets bigger the more lives you have

	FontSetSys(F_8x10);
	DrawStr(40, 15, "GAME OVER", A_NORMAL);
	FontSetSys(F_6x8);
	DrawStr(30, 25, "Score:", A_NORMAL);
	DrawGrayNumb(68, 25, score);

	continueGame = 0;
	keyPress = 1;
	
	if (score > highScore) {
		FontSetSys(F_8x10);
		SetPlane(DARK_PLANE);
		DrawStr(40, 15, "GAME OVER", A_XOR);
		DrawStr(40, 15, "HIGHSCORE", A_NORMAL);
		FontSetSys(F_4x6);
		DrawStr(47, 34, "Enter your name", A_XOR);

		while (keyPushed(KEY_SELECT) || keyPushed(KEY_ALEFT) || keyPushed(KEY_ARIGHT));

		FontSetSys(F_8x10);
		keyPress = 1;
		// Name place 1: 58, 2: 72, 3: 86
		for (i = 0 ; i < 3 ; i++) {
		SetPlane(LIGHT_PLANE);
			DrawChar((12 * i) + 60, 45, highNamet[i], A_XOR);
			SetPlane(DARK_PLANE);
			DrawChar((12 * i) + 60, 45, highNamet[i], A_XOR);
			while (!keyPushed(KEY_SELECT) || keyPress) {
				if (!keyPushed(KEY_SELECT) && !keyPushed(KEY_ALEFT) && !keyPushed(KEY_ARIGHT))
				keyPress = 0;

				if ((keyPushed(KEY_ALEFT) || (keyPushed(KEY_ARIGHT))) && !keyPress) {
					SetPlane(LIGHT_PLANE);
					DrawChar((12 * i) + 60, 45, highNamet[i], A_XOR);
					SetPlane(DARK_PLANE);
					DrawChar((12 * i) + 60, 45, highNamet[i], A_XOR);
					if (keyPushed(KEY_ARIGHT)) highNamet[i]++;
					else highNamet[i]--;
					if (highNamet[i] == 64) highNamet[i] = 57;
					if (highNamet[i] == 47) highNamet[i] = 90;
					if (highNamet[i] == 58) highNamet[i] = 65;
					if (highNamet[i] == 91) highNamet[i] = 48;
					SetPlane(LIGHT_PLANE);
					DrawChar((12 * i) + 60, 45, highNamet[i], A_XOR);
					SetPlane(DARK_PLANE);
					DrawChar((12 * i) + 60, 45, highNamet[i], A_XOR);
					keyPress = 1;
				}
			}
			keyPress = 1;
		}

		SetPlane(DARK_PLANE);
		for (i = 0 ; i < 4 ; i++) {
			DrawChar(60, 45, highNamet[0], A_XOR);
			DrawChar(72, 45, highNamet[1], A_XOR);
			DrawChar(84, 45, highNamet[2], A_XOR);
			for (j = 0 ; j < 300000 ; j++);
		}
		for (i = 0 ; i < 3 ; i++)
			highName[i] = highNamet[i];
		highScore = score;
	}
	else {
		while (continueGame == 0) {											// Pause and wait for input
			for (i = 0 ; i < 600 && continueGame == 0 ; i++) {
				if ((keyPushed(KEY_SELECT) || keyPushed(KEY_ESCAPE)) && !keyPress) {
					keyPress = 1;
					continueGame = 1;
				}
				if (!(keyPushed(KEY_SELECT) || keyPushed(KEY_ESCAPE)))
				keyPress = 0;
			}
		}
	}
}

void DrawGrayNumb(int xPos, int yPos, long value)
{
	int g = 0;				// Position on numBuff: digit number
	char numBuff[12]; // Holds number as a string
	sprintf(numBuff, "%ld", value);
	SetPlane(DARK_PLANE);

	for (g = 0 ; g < (int)strlen(numBuff) ; g++) {
		switch(numBuff[g]) {
			case '0':
				Sprite8((g * 6) + xPos, yPos, 8, digit_0, GetPlane(DARK_PLANE), SPRT_XOR);
				Sprite8((g * 6) + xPos, yPos, 8, digit_0, GetPlane(LIGHT_PLANE), SPRT_XOR); break;
			case '1':
				Sprite8((g * 6) + xPos, yPos, 8, digit_1, GetPlane(DARK_PLANE), SPRT_XOR);
				Sprite8((g * 6) + xPos, yPos, 8, digit_1, GetPlane(LIGHT_PLANE), SPRT_XOR); break;
			case '2':
				Sprite8((g * 6) + xPos, yPos, 8, digit_2, GetPlane(DARK_PLANE), SPRT_XOR);
				Sprite8((g * 6) + xPos, yPos, 8, digit_2, GetPlane(LIGHT_PLANE), SPRT_XOR); break;
			case '3':
				Sprite8((g * 6) + xPos, yPos, 8, digit_3, GetPlane(DARK_PLANE), SPRT_XOR);
				Sprite8((g * 6) + xPos, yPos, 8, digit_3, GetPlane(LIGHT_PLANE), SPRT_XOR); break;
			case '4':
				Sprite8((g * 6) + xPos, yPos, 8, digit_4, GetPlane(DARK_PLANE), SPRT_XOR);
				Sprite8((g * 6) + xPos, yPos, 8, digit_4, GetPlane(LIGHT_PLANE), SPRT_XOR); break;
			case '5':
				Sprite8((g * 6) + xPos, yPos, 8, digit_5, GetPlane(DARK_PLANE), SPRT_XOR);
				Sprite8((g * 6) + xPos, yPos, 8, digit_5, GetPlane(LIGHT_PLANE), SPRT_XOR); break;
			case '6':
				Sprite8((g * 6) + xPos, yPos, 8, digit_6, GetPlane(DARK_PLANE), SPRT_XOR);
				Sprite8((g * 6) + xPos, yPos, 8, digit_6, GetPlane(LIGHT_PLANE), SPRT_XOR); break;
			case '7':
				Sprite8((g * 6) + xPos, yPos, 8, digit_7, GetPlane(DARK_PLANE), SPRT_XOR);
				Sprite8((g * 6) + xPos, yPos, 8, digit_7, GetPlane(LIGHT_PLANE), SPRT_XOR); break;
			case '8':
				Sprite8((g * 6) + xPos, yPos, 8, digit_8, GetPlane(DARK_PLANE), SPRT_XOR);
				Sprite8((g * 6) + xPos, yPos, 8, digit_8, GetPlane(LIGHT_PLANE), SPRT_XOR); break;
			case '9':
				Sprite8((g * 6) + xPos, yPos, 8, digit_9, GetPlane(DARK_PLANE), SPRT_XOR);
				Sprite8((g * 6) + xPos, yPos, 8, digit_9, GetPlane(LIGHT_PLANE), SPRT_XOR); break;
		}
	}
}


/*===========================================================================*/
/* utility function to test for pressed keys																 */
/*===========================================================================*/
int keyPushed(int keyQ) {
//	static short keyPushed = 0;
	if (TI89) {															// If we are using the ti89 calculator
		switch(keyQ) {
			case KEY_SELECT:	 // Select is both 2nd and Enter
				if ((_rowread(0xFFFD) & 1) || (_rowread(0xFFFE) & 16)) return(1);
				break;
			case KEY_TURBO:		 // Turbo is Diamond
				if (_rowread(0xFFFE) & 64) return(1);
				break;
			case KEY_AUP:			 // Up button
				if (_rowread(0xFFFE) & 1) return(1);
				break;
			case KEY_ALEFT:		 // Left button
				if (_rowread(0xFFFE) & 2) return(1);
				break;
			case KEY_ADOWN:		 // Down button
				if (_rowread(0xFFFE) & 4) return(1);
				break;
			case KEY_ARIGHT:	 // Right button
				if (_rowread(0xFFFE) & 8) return(1);
				break;
			case KEY_ESCAPE:	// ESC button
				if (_rowread(0xFFBF) & 1) return(1);
		}
	} else {																// If we are using the ti92p calc
		switch(keyQ) {
			case KEY_SELECT:	 // Select is 2nd, Enter1 and Enter2
				if ((_rowread(0xFDFF) & 2) || (_rowread(0xFFBF) & 64) || (_rowread(0xFFFE) & 1)) return(1);
				break;
			case KEY_TURBO:		 // Turbo is Diamond
				if (_rowread(0xFFFE) & 2) return(1);
				break;
			case KEY_AUP:			 // Up button
				if (_rowread(0xFFFE) & 32) return(1);
				break;
			case KEY_ALEFT:		 // Left button
				if (_rowread(0xFFFE) & 16) return(1);
				break;
			case KEY_ADOWN:		 // Down button
				if (_rowread(0xFFFE) & 128) return(1);
				break;
			case KEY_ARIGHT:	 // Right button
				if (_rowread(0xFFFE) & 64) return(1);
				break;
			case KEY_ESCAPE:	 // ESC button
				if (_rowread(0xFEFF) & 64) return(1);
		}
	}
	return(0);
}

int turboUpdate(int takeFill) {
	static short moves = 4, bars = 8;
	
	if (takeFill == 2) {				 // If we are filling it up
		moves = 8; bars = 8;
		return 1;
	}

	if (moves || bars) {
		if (takeFill == 1) {			 // If we are making a turbo move
			if (--moves == 0) {
				moves = 4;
				bars--;
			}
		}
		return 1;
	}	else
	return 0;
}
